CF-219D Choosing Capital for Treeland

2024-01-08 14:08

本文主要是介绍CF-219D Choosing Capital for Treeland,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

The country Treeland consists of n cities, some pairs of them are connected with unidirectional roads. Overall there are n - 1 roads in the country. We know that if we don't take the direction of the roads into consideration, we can get from any city to any other one.

The council of the elders has recently decided to choose the capital of Treeland. Of course it should be a city of this country. The council is supposed to meet in the capital and regularly move from the capital to other cities (at this stage nobody is thinking about getting back to the capital from these cities). For that reason if city a is chosen a capital, then all roads must be oriented so that if we move along them, we can get from city a to any other city. For that some roads may have to be inversed.

Help the elders to choose the capital so that they have to inverse the minimum number of roads in the country.

Input

The first input line contains integer n (2 ≤ n ≤ 2·105) — the number of cities in Treeland. Next n - 1 lines contain the descriptions of the roads, one road per line. A road is described by a pair of integers si, ti (1 ≤ si, ti ≤ nsi ≠ ti) — the numbers of cities, connected by that road. The i-th road is oriented from city si to city ti. You can consider cities in Treeland indexed from 1 to n.

Output

In the first line print the minimum number of roads to be inversed if the capital is chosen optimally. In the second line print all possible ways to choose the capital — a sequence of indexes of cities in the increasing order.

Examples
Input
3
2 1
2 3
Output
0
2 
Input
4
1 4
2 4
3 4
Output
2
1 2 3 

题目大意:

一个国家由n个城市组成,这n个城市有n-1条单向道路,国家委员会决定在这n个城市中选择一个城市作为首都,作为首都的城市有一个要求,就是能通过道路到达每一个城市。所以当选择一个城市作为首都之后,就有一部分单向道路要被反转,问你选择哪些城市作为首都,需要反转的道路最少。

解题思路:

还是两边dfs。

第一个dfs求出将该结点作为首都,它的子树有多少条道路需要反转。

第二版dfs求出将该结点作为首都,它往上面走有多少条道路需要反转。

两个加起来就可以了。

通过这道题,我突然发现之前的树形DP写的有问题,如果是菊花图就会TLE,第二次的dfs没必要再去遍历兄弟节点,只需要做一个容斥就好了

#include <iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
#include<map>
#include<queue>using namespace std;
const long long inf = 0x3f3f3f3f;
const int maxn = 200005;int n, m, k;struct Edge
{int to,nxt,tag;
} edges[maxn<<2];
int head[maxn<<2];
int tot;void addEdge(int u, int v, int tag)
{edges[tot] = Edge{v,head[u],tag};head[u] = tot++;
}int dp1[maxn]; //从该结点往下走有多少条道路需要反转
int dp2[maxn]; //从该节点往上走有多少条道路需要反转void dfs1(int u, int fa)
{dp1[u] = 0;for(int i = head[u]; ~i; i = edges[i].nxt){int v = edges[i].to;int tag = edges[i].tag;if(v==fa)continue;dfs1(v,u);dp1[u]+=tag+dp1[v];}
}
void dfs2(int u, int fa)
{for(int i = head[u]; ~i; i = edges[i].nxt){int v = edges[i].to;int tag = edges[i].tag;if(v == fa)continue;dp2[v] = dp1[u]-dp1[v]-tag+dp2[u]+(tag^1);dfs2(v,u);}
}vector<int>v1;int main()
{int n;scanf("%d", &n);int u, v;tot = 1;memset(head,-1,sizeof(head));for(int i = 1; i < n; i++){scanf("%d%d", &u, &v);addEdge(u,v,0);addEdge(v,u,1);}dfs1(1,-1);dfs2(1,0);int minn = inf;for(int i = 1; i <= n; i++){dp1[i]+=dp2[i];minn = min(minn,dp1[i]);}for(int i = 1; i <= n; i++){if(minn == dp1[i])v1.push_back(i);}printf("%d\n", minn);int len = v1.size();for(int i = 0; i < len; i++){printf("%d ", v1[i]);}printf("\n");return 0;
}

 

 

 

这篇关于CF-219D Choosing Capital for Treeland的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/583708

相关文章

博弈论+递推+调和级数枚举,CF 1033C - Permutation Game

一、题目 1、题目描述 2、输入输出 2.1输入 2.2输出 3、原题链接 1033C - Permutation Game 二、解题报告 1、思路分析 我们考虑一个位置符合什么条件可以必胜? 如果可以跳到一个必败的位置 考虑最大的格子一定是必败 而每个格子只能跳到比自己大的格子 于是我们就可以倒序处理状态 对于每个格子枚举比自己大

前缀和+双指针,CF 131F - Present to Mom

一、题目 1、题目描述 2、输入输出 2.1输入 2.2输出 3、原题链接 131F - Present to Mom 二、解题报告 1、思路分析 很经典的一种把列看作cell 来进行双指针/递推的题型 我们考虑,可以预处理出原矩阵中的所有star 然后我们去枚举矩形的上下边界,把边界内的每列当成一个格子的话,问题就变成了求和至少大于等于

处女座与cf

【题目描述】 众所周知,处女座经常通过打cf来调节自己的心情。今天处女座又参加了一场cf的比赛,他知道了所有的提交记录,他想知道自己的得分和排在第几名。你知道处女座的cf账号是cnz Codeforces规则如下: 1.比赛一共2小时 2.比赛有5题,A题500分,B题1000分,C题1500分,D题2000分,E题2500分。 3.得分规则如下: 在第 0 分钟完成某一题可以得到全部的分数,每

如何实现“变”CF而不变有效值

存在一些特殊需求,需要在保证有效值不变的情况下,“改变”正弦波的峰值因数(CF),如图,由绿色波形变为灰色波形: 正常的正弦波为 f ( t ) = 2 A ⋅ s i n ( 2 π T t ) f(t)=\sqrt{2}A\cdot sin(\frac{2\pi}{T}t) f(t)=2 ​A⋅sin(T2π​t) ,CF值为 2 \sqrt{2} 2 ​ ,其中 A 为有效值,

线性DP,状态优化,CF 958C2 - Encryption (medium)

一、题目 1、题目描述 2、输入输出 2.1输入 2.2输出 3、原题链接 Problem - 958C2 - Codeforces 二、解题报告 1、思路分析 明显的dp 我们可以写一个会超时的朴素dp 状态定义 f[i][j]为前i个数字,划分为j组的最大收益 那么f[i][j] = max{ f[x][j - 1] + sum(

Codeforces #246 (Div. 2) A. Choosing Teams

水题一道,但是题意不太好理解 给定n k以及n个人已参加的比赛数 让你判断最少还能参加k次比赛的队伍数 每对3人,每个人最多参加5次比赛 代码如下: #include <cstdio>#include <iostream>#include <algorithm>#define MAXN 10010#define ll long longusing namespace std

二分+ST表+递推,Cf 1237D - Balanced Playlist

一、题目 1、题目描述 2、输入输出 2.1输入 2.2输出 3、原题链接 Problem - 1237D - Codeforces 二、解题报告 1、思路分析 case3提示我们一件事情:如果存在某个位置永远不停止,那么所有位置都满足永远不停止 很容易证明 随着下标右移,区间最大值不会变大,那么后面2倍大于旧的最大值的数的二倍仍然大于新

cf 363D

贪心加二分 虽然比赛后才过 ........ /*************************************************************************> Author: xlc2845 > Mail: xlc2845@gmail.com> Created Time: 2013年11月10日 星期日 19时35分23秒**********

cf 359A 359B

359A 如果有点在边上则最少两次 没有则最少操作4次 #include <cstdio>#include <cstring>#include <algorithm>#include <cstdlib>using namespace std;int g[50][50],n,m;int main(){bool flag = false;scanf("%d%d",&n,&m);for(

cf 359C

stl 里的map使用   然后就是快速幂取余 #include <cstdio>#include <cstring>#include <algorithm>#include <cstdlib>#include <map>#define LL long long#define mod 1000000007using namespace std;LL num[100010];